Subject: Re: [PATCH] git-latexdiff: new command in contrib, to use latexdiff and Git

From: Matthieu Moy <[email-masked]>
Date: Fri, 17 Feb 2012 09:10:46 +0100

Junio C Hamano <[email-masked]> writes:

> Honestly speaking, this is looking more like an "useful application for
> latex users who happen to use git to store their document source", and not
> a "useful addition for all git users", to me.
>
> These two viewpoint suggests completely different evolution path for this
> program.  Imagining what the first major new enhancement intended for
> people outside the original audience <git,latex> will be, I have this
> suspicion that "this new version will help people who have their documents
> stored in Mercurial" would be much more realistic (and the end result
> being useful) than "this new version will help git users who do not write
> their documents in latex but in asciidoc".

I agree that the next step may be to allow users of <whatever SCM
outside Git>, but I don't think the way to do that would be to make the
script generic. The script is a quick hack, and all the "clever" parts
of it are calls to Git. If someone were to adapt this for Mercurial or
Bzr, writting a python plugin would be a much better way to go
(Mercurial already has "hg extdiff" doing the hardlinked checkouts for
example, and both would allow better command-line option parsing than
my "case $1 in ... esac").

I normally like code reuse very much, but trying to make a 250 lines
long script generic enough to accept multiple SCMs would be more work
than a rewrite.

OTOH, having this script in contrib/ has several advantages over
maintaining it as a separate one-file project:

- "make install" uses Git's Makefile configuration, so it's easy to
  install.

- It makes it natural to use this mailing list for discussion. The
  script has already improved a lot since I posted it as a patch here.

-- 
Matthieu Moy
http://www-verimag.imag.fr/~moy/